interval 60

warning 5

settings :file_mask, '.*'
settings :dir, '/tmp/dir'
settings :age, 24 * 60 * 60

collect do
  if File.directory?(settings.dir)
    count_files = 0
    file_mask = Regexp.new(settings.file_mask)
    Find.find(settings.dir).each do |file|
      next unless File.file? file
      next unless file_mask.match file
      next unless Time.now.to_i - settings.age > File.new(file).mtime.to_i
      count_files += 1
    end
    event(:service => "find files #{settings.dir}", :metric => count_files, :description => "Count files in #{settings.dir}")
  end
end
