always_start true
interval 60

settings :file, '/etc/nginx/sites-enabled/status'
settings :url, 'http://127.0.0.1:11311/status'
settings :nginx_status_1, %W(accepts handled requests)
settings :nginx_status_2, %W(reading writing waiting)

run_if 'linux', 'mac_os_x' do
  File.exists? settings.file
end

collect 'linux', 'mac_os_x' do
  lines = http_get(settings.url).split("\n")
  lines[2].scan(/\d+/).each_with_index do |value, index|
    event(:service => "nginx #{settings.nginx_status_1[index]}", :metric => value.to_f/interval, :diff => true)
  end
  event(:service => 'nginx active', :metric => lines[0].split(':')[1].strip.to_i)
  lines[3].scan(/\d+/).each_with_index do |value, index|
    event(:service => "nginx #{settings.nginx_status_2[index]}", :metric => value.to_i)
  end
end
