require 'rest_client'
require 'uri'

module Malevich
  module PluginHelpers

    def http_get(url)
      RestClient.get(url)
    end

    alias :rest_get :http_get

    def body_get(url)
      case URI.parse(url).scheme
        when 'http', 'https'
          http_get(url)
        when 'file'
          raise "body_get('#{url}'): hasn't support yet"
        else
          File.read(url)
      end
    end

  end
end
