# https://raw.github.com/rails/rails/master/activesupport/lib/active_support/core_ext/hash/deep_merge.rb
module Malevich
  class Hashie < Hash

    def deep_merge(other_hash, &block)
      dup.deep_merge!(other_hash, &block)
    end

    def deep_merge!(other_hash, &block)
      other_hash.each_pair do |k,v|
        tv = self[k]
        if tv.is_a?(Hash) && v.is_a?(Hash)
          self[k] = tv.deep_merge(v, &block)
        else
          self[k] = block && tv ? block.call(k, tv, v) : v
        end
      end
      self
    end

    def method_missing(method_name, *args, &blk)
      self.[](method_name.to_sym, &blk)
    end

  end
end
